package com.xhkjedu.sstudy.service.gradeclass;

import com.xhkjedu.sstudy.mapper.gradeclass.ClassMapper;
import com.xhkjedu.utils.N_Utils;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * @Description 班级
 * @Author WN
 * @Date 2023/4/12 14:30
 **/
@Service
public class ClassService {
    @Resource
    private ClassMapper classMapper;

    /*
    * @Description 获取教师权限下班级包含伙伴学校
    * @Author WN
    * @Date 2023/4/12 14:31
    */
    public Map getQxClassidsByTeacherid(Integer teacherid, Integer year){
        //获取教师权限下班级包含集团校
        List<Map> classlist = classMapper.listQxClassByTeacherid(teacherid, year);

        //所有权限班级集合
        List<Integer> classidlist = classlist.stream().map(s -> Integer.parseInt(s.get("classid").toString())).collect(Collectors.toList());
        //本校班级集合
        List<Integer> bxclassidlist = classlist.stream().filter(c -> c.get("schoolid").equals(c.get("userschoolid")))
                                               .map(s -> Integer.parseInt(s.get("classid").toString())).collect(Collectors.toList());

        String classids = StringUtils.join(classidlist, ",");
        String bxclassids = StringUtils.join(bxclassidlist,",");
        if(N_Utils.isEmpty(classids)) classids = "0";
        if(N_Utils.isEmpty(bxclassids)) bxclassids = "0";

        Map rtnmap = new HashMap();
        rtnmap.put("classids",classids);
        rtnmap.put("bxclassids",bxclassids);

        return rtnmap;
    }
}
